<?php

use Automattic\WooCommerce\Blocks\Payments\Integrations\AbstractPaymentMethodType;

final class Woo_PayPal_Pro_Block extends AbstractPaymentMethodType {

    private $gateway;
    protected $name = 'paypal_pro';
    public $pay_later;
    public $version;

    public function initialize() {
        $this->version = WOO_PAYPAL_PRO_PLUGIN_VERSION;
        if (!class_exists('Easy_Woo_PayPal_Pro_Gateway')) {
            include_once ( WOO_PAYPAL_PRO_PLUGIN_DIR . '/includes/class-woo-paypal-pro-gateway.php');
        }
        $this->gateway = new Easy_Woo_PayPal_Pro_Gateway();
    }

    public function is_active() {
        return $this->gateway->is_available();
    }

    public function get_payment_method_script_handles() {
        wp_enqueue_script('wc-credit-card-form');
        wp_enqueue_style('unique-credit-card-form-css', PAYPAL_PRO_PLUGIN_ASSET_URL . 'checkout-block/ppcp-paypal-pro.css', array(), $this->version, 'all');
        wp_register_script('easy_paypal_pro_blocks_integration', PAYPAL_PRO_PLUGIN_ASSET_URL . 'checkout-block/ppcp-pro-block.js', array('jquery', 'react', 'wc-blocks-registry', 'wc-settings', 'wp-element', 'wp-i18n', 'wp-polyfill', 'wp-element', 'wp-plugins'), WPG_PLUGIN_VERSION, true);
        if (function_exists('wp_set_script_translations')) {
            wp_set_script_translations('easy_paypal_pro_blocks_integration', 'woo-paypal-pro');
        }
        return ['easy_paypal_pro_blocks_integration'];
    }

    public function get_payment_method_data() {
        return [
            'cc_title' => $this->gateway->title,
            'description' => $this->get_setting('description'),
            'supports' => $this->get_supported_features(),
            'icons' => $this->gateway->icon
        ];
    }
}
